package prefuse.controls;

import java.awt.event.KeyEvent;

import prefuse.Display;
import prefuse.visual.VisualItem;
import cytoPrefuse.EdgeBundler;

public class SplineBetaController extends ControlAdapter {
	
	private EdgeBundler edgeBundler;
	private int beta = 10;
	
	public SplineBetaController(EdgeBundler edgeBundler){
		this.edgeBundler = edgeBundler;
	}
	  public void keyTyped(KeyEvent e) {
	    	adjustBeta(e);
	    } 
	    public void itemKeyTyped(VisualItem item, KeyEvent e) {
	    	adjustBeta(e);
	    } 
	    private void adjustBeta(KeyEvent e) {
	        
	    	boolean betaChanged = false;
	        if ( e.getKeyChar() == 'b') {
	        	 beta += 1;
	        	 betaChanged =true;
	        }else if (e.getKeyChar() == 'v'){
	        	beta -= 1;
	        	betaChanged = true;
	        }else if (e.getKeyChar() == 'c'){
	        	beta = 0;
	        	betaChanged = true;
	        }else if (e.getKeyChar()=='n'){
	        	beta = 10;
	        	betaChanged = true;
	        }
		    if (betaChanged) {
		        if (beta > 10){
		        	beta = 10;
		        }else  if (beta < 0){
		        	beta = 0;
		        }else {
		        	edgeBundler.setBeta(beta * 0.1f);
		            Display d = (Display)e.getSource();
		            d.getVisualization().run("color");
			        d.repaint();			   
		        }
		    }
	        
	    }
}
